/***************************************************/
/*   Definies de parmetros do jogo              */
/***************************************************/

#ifndef _PARAMETROS_H_
#define _PARAMETROS_H_

// Dimenses do campo (m)

#define LARGURA_CAMPO 1.50
#define ALTURA_CAMPO 1.30
// Dimenses da trave
#define LARGURA_TRAVE 0.10
#define ALTURA_TRAVE 0.40
// Largura/altura da quina
#define TAMANHO_QUINA 0.07
// Raio do crculo central
#define RAIO_CIRCULO 0.20
// Dimenses da grande rea
#define ALTURA_AREA 0.70
#define LARGURA_AREA 0.15
#define ALTURA_ARCO 0.20
#define LARGURA_ARCO 0.05

//dimensoes para o penalti e para as bolas livres
#define MARCA_PENALTI 0.375
#define MARCA_BOLA_LIVRE 0.4
#define DISTANCIA_BOLA_LIVRE_ROBOS 0.2
#define RAIO_CIRCULO_BOLA_LIVRE 0.01

// Dimenses dos objetos (m)

// Rob
#define LADO_ROBO 0.075
#define RAIO_ROBO (LADO_ROBO/sqrt(2.0))
#define RAIO_MARCA_ROBO 0.01875
// Bola
#define RAIO_BOLA 0.02135

// Parmetros do modelo dinmico

// Velocidade angular mxima dos motores (em rad/s = PI*rpm/30)
#define VEL_MOTOR 100
// Raio das duas rodas (em metros)
#define RAIO_RODA 0.015
// Massa do rob (em kg)
#define MASSA_ROBO 0.3
// Para efeito de clculo do momento de inrcia, supe-se que a massa
// do rob est distribuda em um crculo em torno do ponto central.
// O raio deste crculo pode variar de 0 (0%) a LADO_ROBO/2 (100%). A
// constante AFAST_MASSA, que varia de 0.0 a 1.0, d este percentual.
// O momento de inrcia  diretamente proporcional a AFAST_MASSA.
#define AFAST_MASSA 0.9
// Constante de tempo do movimento linear do rob (em seg)
#define CONST_TEMPO_LIN 2.0
// Massa da bola (em kg)
#define MASSA_BOLA 0.09
// Constante de tempo da bola (em seg)
#define CONST_TEMPO_BOLA 0.25

// Perodo de amostragem (s)
#define T_AMOSTR 0.033

#endif
