#include <iostream>

#include "ssocket.h"
#include "aquisicao.h"

using namespace std;

Aquisicao::Aquisicao(TIME time): Futdados(time)
{
}
 
bool Aquisicao::aquisicao(udpSocket &sock)
{
  static SITUACAO minhaSit;
  SOCKET_STATUS retorno;

  // Espera por uma imagem no socket; l�todas as dispon�eis e guarda a ltima
  if (!sock.connected()) {
    cerr << "Servidor n� conectado\n";
    return true;
  }
  do {
    retorno = sock.read((void *)&minhaSit, sizeof(SITUACAO));
    if( retorno == SOCKET_OK ) {
      fsocket fila;
      fila.include(sock);
      retorno = fila.wait_read(0);
      if( retorno != SOCKET_TIMEOUT && retorno != SOCKET_OK ) {
	cerr << "Erro na fila interna de socket" << endl;
	return true;
      }
    }
    else {
      cerr << "Erro na leitura da c�era do simulador" << endl;
      sock.close();
      return true;
    }
  } while( retorno == SOCKET_OK );
  id_pos = minhaSit.id;
  if (id_pos-id_ant!=1 && id_ant!=0) {
    cerr << "Quadros perdidos: anterior=" << id_ant
	 << " atual=" << id_pos << endl;
  }
/*  if (estado!=TERMINAR) {
    estado = minhaSit.estado;
  }*/
//  gols.azul = minhaSit.gols.azul;
//  gols.amrl = minhaSit.gols.amrl;
  for (int i=0; i<3; i++) {
    if (meuTime() == TIME_AZUL) {
      pos.meu[i] = minhaSit.pos.azul[i];
      pos.adv[i] = minhaSit.pos.amrl[i];
    }
    else {
      pos.meu[i] = minhaSit.pos.amrl[i];
      pos.adv[i] = minhaSit.pos.azul[i];
    }
  }
  pos.bola = minhaSit.pos.bola;
  return false;
}
