#include <iostream>
#include <cmath>
#include "parametros.h"
#include "funcoes.h"
#include "estrategia.h"

Estrategia::Estrategia(TIME time): Futdados(time)
{
  t = 0.0;
}
 
bool Estrategia::estrategia()
{
  static double ultimo_t = 0.0, sinal=1.0;;

  if (meuTime() == TIME_AMARELO) {
    // Trajetoria linear
    ref.meu[0].x = (LARGURA_CAMPO/2.0-LARGURA_AREA)*sin(0.3*t);
    ref.meu[0].y = 0.0;
    ref.meu[0].theta = 0.0;
    // Mudancas abruptas
    ref.meu[1].x = 0.4;
    ref.meu[1].y = sinal*0.5;
    ref.meu[1].theta = M_PI_4*sinal;
    // Circulo
    ref.meu[2].x = RAIO_CIRCULO*cos(t);
    ref.meu[2].y = RAIO_CIRCULO*sin(t);
    ref.meu[2].theta = ang_equiv2(t-M_PI_2);
  }
  else {
    // Trajetoia linear
    ref.meu[0].x = -(LARGURA_CAMPO/2.0-LARGURA_AREA);
    ref.meu[0].y = (ALTURA_AREA/2.0)*sin(t/2);
    ref.meu[0].theta = M_PI_2;
    // Chutar bola para o gol
    if (fabs(pos.bola.x)<0.4 &&
	pos.bola.x>pos.meu[1].x) {
      ref.meu[1].x = pos.bola.x;
      ref.meu[1].y = pos.bola.y;
      ref.meu[1].theta = arc_tang(-pos.bola.y,LARGURA_CAMPO/2.0-pos.bola.x);
    }
    else {
      ref.meu[1].x = -0.4;
      ref.meu[1].y = pos.bola.y;
      ref.meu[1].theta = 0.0;
    }
    // Circulo
    ref.meu[2].x = RAIO_CIRCULO*cos(t);
    ref.meu[2].y = RAIO_CIRCULO*sin(t);
    ref.meu[2].theta = ang_equiv2(t-M_PI_2);
  }
  if (t-ultimo_t > 11.0) {
    ultimo_t = t;
    sinal = -sinal;
  }
  
  t+=T_AMOSTR; 
  return false;
}
 
bool Estrategia::suspender_estrategia()
{
  for (int i=0; i<3; i++) {
    ref.meu[i].x = pos.meu[i].x;
    ref.meu[i].y = pos.meu[i].y;
    ref.meu[i].theta = pos.meu[i].theta;
  }
  return false;
}
