#include <iostream>

#include "dados.h"
#include "futrobot.h"

using namespace std;

// CLASSE FUTDADOS

Futdados::Futdados(TIME time)
{
  meu_time = time;
  meu_lado = (time==TIME_AZUL ? LADO_ESQUERDO : LADO_DIREITO);
  estado = ATIVO;
  gols.azul = gols.amrl = 0;
  id_ant = id_pos = 0;
}

void Futdados::imprime_estado(void) const
{
  cout << "+------------------------------------"
       << "-----------------------------------+\n";
  printf( "| %6lu ", id_pos);
  printf( "|           MEUS       %3u ",
	  meu_time==TIME_AZUL ? gols.azul : gols.amrl);
  printf( "x %-3u     ADVERSRIO       ",
	  meu_time==TIME_AZUL ? gols.amrl : gols.azul);
  printf( "|        |\n");
  // Nunca se imprime quando o estado  TERMINAR
  printf( "| %6.6s ", estado==ATIVO ? "ATIVO" : "SUSPENSO");
  cout << "| 0 CIAN | 1 ROSA | 2 VERD "
       << "| 0 CIAN | 1 ROSA | 2 VERD "
       << "|   BOLA |\n";
  cout << "+------------------------------------"
	   << "-----------------------------------+\n";
  printf( "| Ref x  ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", ref.meu[0].x,
	  ref.meu[1].x, ref.meu[2].x);
  printf( "| ------ | ------ | ------ ");
  printf( "| ------ |\n");
  printf( "| Ref y  ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", ref.meu[0].y,
	  ref.meu[1].y, ref.meu[2].y);
  printf( "| ------ | ------ | ------ ");
  printf( "| ------ |\n");
  printf( "| Theta  ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", ref.meu[0].theta,
	  ref.meu[1].theta, ref.meu[2].theta);
  printf( "| ------ | ------ | ------ ");
  printf( "| ------ |\n");
  cout << "+------------------------------------"
       << "-----------------------------------+\n";
  printf( "| Pos x  ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", pos.meu[0].x,
	  pos.meu[1].x, pos.meu[2].x);
  printf( "| %+6.3f | %+6.3f | %+6.3f ", pos.adv[0].x,
	  pos.adv[1].x, pos.adv[2].x);
  printf( "| %+6.3f |\n", pos.bola.x);
  printf( "| Pos y  ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", pos.meu[0].y,
	  pos.meu[1].y, pos.meu[2].y);
  printf( "| %+6.3f | %+6.3f | %+6.3f ", pos.adv[0].y,
	  pos.adv[1].y, pos.adv[2].y);
  printf( "| %+6.3f |\n", pos.bola.y);
  printf( "| Theta  ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", pos.meu[0].theta,
	  pos.meu[1].theta, pos.meu[2].theta);
  printf( "| %+6.3f | %+6.3f | %+6.3f ", pos.adv[0].theta,
	  pos.adv[1].theta, pos.adv[2].theta);
  printf( "| ------ |\n");
  cout << "+------------------------------------"
	   << "-----------------------------------+\n";
  printf( "| Ctrl d ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", ctrl.meu[0].right,
	  ctrl.meu[1].right, ctrl.meu[2].right);
  printf( "| ------ | ------ | ------ ");
  printf( "| ------ |\n");
  printf( "| Ctrl e ");
  printf( "| %+6.3f | %+6.3f | %+6.3f ", ctrl.meu[0].left,
	  ctrl.meu[1].left, ctrl.meu[2].left);
  printf( "| ------ | ------ | ------ ");
  printf( "| ------ |\n");
  cout << "+------------------------------------"
	   << "-----------------------------------+\n";
}
