#include <iostream>
#include <cmath>

#include "parametros.h"
#include "sistema.h"
#include "comunicacao.h"
#include "funcoes.h"
#include "futrobot.h"

#define JOGANDO true
#define IMOVEL false

using namespace std;

Futrobot::~Futrobot()
{
  pthread_join(thr_ctrl, NULL);
  if (sock.connected()) sock.close();
  cout << "Futrobot concluido!\n";
}

// Laco principal do programa (thread de controle dos robos)

inline void* main_futrobot(void *x){
  ((Futrobot*)x)->main_futrobot();
  return NULL;
}
/*
bool Futrobot::estadoCliente()
{
  return estado;
}

void Futrobot::setEstadoCliente(bool est)
{
  estado = est;
}*/

void Futrobot::main_futrobot()
{
  while (estJogo() != TERMINAR) {
    id_ant = id_pos;
    // Espera pelos dados com as posicoes atuais dos robos e da bola
    if (estJogo() != TERMINAR && aquisicao(sock)) {	
      terminar();
    }
    if (estJogo() == ATIVO) {
      // Calcula as posicoes finais desejadas para os robos
      if (estJogo() != TERMINAR && estrategia()) {
	terminar();
      }
      // Recalcula as posicoes finais para evitar os obstaculos
      if (estJogo() != TERMINAR && obstaculos()) {
	terminar();
      }
      // Calcula o novo controle (ou seja, as novas tensoes dos motores)
      if (estJogo() != TERMINAR && controle()) {
	terminar();
      }
      // Informa tensoes dos motores para os robos
      if (estJogo() != TERMINAR && transmissao(sock)) {
	terminar();
      }
    }else {    // Jogo suspenso (DESABILITADO!!!!)
      suspender_estrategia();
      suspender_controle();
      if(transmissao(sock))
	terminar();
    }
  }
  // Parada final dos motores
  for( int i=0; i<3; i++ ) {
    ctrl.meu[i].right = 0.0;
    ctrl.meu[i].left  = 0.0;
  }
  transmissao(sock);
}

// O programa principal (interface)

static void erro(SOCKET_STATUS err, const char *msg){}

int main( int argc, char **argv )
{
  if( argc<2 ) {
    cerr << "Passe como argumento o endereco IP do simulador\n";
    exit(1);
  }

  // Para que a biblioteca de sockets nao faca nada em caso de "erros"
  // (por exemplo, de timeouts). Ela deve apenas retornar o codigo de
  // erro, para que eu trate aqui no programa principal.
  socket_error = erro;

  TIME meuTime;
  const char *ip_simulador = argv[1];

  set_keypress();
  char tecla = '0';

  cout << "**************************************\n";
  cout << "*           FUTEBOL DE ROBOS         *\n";
  cout << "**************************************\n";

  do {
    cout << "\nOpcoes disponiveis:\n";
    cout << "1 - Uniforme azul!\n";
    cout << "2 - Uniforme amarelo!\n";
    cout << "SUA OPCAO: ";

    do {
      tecla = pega_caracter();
    } while (tecla==EOF || tecla=='\n');
  }while(tecla!='1' && tecla!='2');
  cout << endl;

  if (tecla=='1') {
    meuTime=TIME_AZUL;
  }
  else {
    meuTime=TIME_AMARELO;
  }

  // Na criacao desta variavel, o construtor lanca a thread que faz o
  // controle do sistema propriamente dito

  Futrobot fut(meuTime, ip_simulador);
  while (fut.estJogo() != TERMINAR) {
    if(fut.estJogo() == SUSPENSO){
    do {
      cout << "\nOpcoes disponiveis:\n";
      cout << "P - Para im(P)rimir posicoes atuais\n";
      cout << "G - (G)ol\n";
      //cout << "I - (I)mobilidade\n";
      cout << "C - (C)ontinuar\n";
      cout << "B - (B)ola-Livre   (Free-Ball)\n";
      cout << "M - Tiro-de-(M)eta (Goal-Kick)\n";
      cout << "N - Pe(N)alti      (Penalty-Kick)\n";
      cout << "L - Tiro-(L)ivre   (Free-Kick)\n";
      cout << "T - Para (T)erminar a partida\n";
      cout << "SUA OPCAO: "; 
      
      do {
        tecla = pega_caracter();
      }
      while (tecla==EOF && fut.estJogo()!=TERMINAR);
      
      if (fut.estJogo()==TERMINAR) {
        tecla = 'T';
        cout << tecla;
      }
      else {
        tecla = toupper(tecla);
      }
      cout << '\n';
    }
    while (tecla != 'T' && tecla != 'G' /*&& tecla != 'I'*/ && tecla != 'B' && tecla != 'M' && tecla != 'N' && tecla != 'L' && tecla != 'P' && tecla != 'C');
    }else{
    do {
      cout << "\nOpcoes disponiveis:\n";
      cout << "P - Para im(P)rimir posicoes atuais\n";
      //cout << "G - (G)ol\n";
      cout << "I - (I)mobilidade\n";
      //cout << "C - (C)ontinuar\n";
      //cout << "B - (B)ola-Livre   (Free-Ball)\n";
      //cout << "M - Tiro-de-(M)eta (Goal-Kick)\n";
      //cout << "N - Pe(N)alti      (Penalty-Kick)\n";
      //cout << "L - Tiro-(L)ivre   (Free-Kick)\n";
      cout << "T - Para (T)erminar a partida\n";
      cout << "SUA OPCAO: "; 
      
      do {
        tecla = pega_caracter();
      }
      while (tecla==EOF && fut.estJogo()!=TERMINAR);
      
      if (fut.estJogo()==TERMINAR) {
        tecla = 'T';
        cout << tecla;
      }
      else {
        tecla = toupper(tecla);
      }
      cout << '\n';
    }
    while (tecla != 'T' /*&& tecla != 'G'*/ && tecla != 'I' /*&& tecla != 'B' && tecla != 'M' && tecla != 'N' && tecla != 'L' */&& tecla != 'P' /*&& tecla != 'C'*/);
    }

    switch (tecla) {
    case 'T':
      fut.terminar();
      break;
    case 'G':
      cout << "\nOpcao nao implementada!\n\n";
      break;
    case 'I':
	//fut.setEstadoCliente(IMOVEL);
	fut.suspender();
      cout << "\nOpcao nao implementada!\n\n";
      break;
    case 'B':
      cout << "\nOpcao nao implementada!\n\n";
      break;
    case 'M':
      cout << "\nOpcao nao implementada!\n\n";
      break;
    case 'N':
      cout << "\nOpcao nao implementada!\n\n";
      break;
    case 'L':
      cout << "\nOpcao nao implementada!\n\n";
      break;
    case 'P':
      fut.imprime_estado();
      break;
    case 'C':
	//fut.setEstadoCliente(JOGANDO);
	fut.ativar();
      cout << "\nOpcao nao implementada!\n\n";
      break;
    }
  }
 
  reset_keypress();
  return(0);
}


Futrobot::Futrobot(TIME time, const char *ip): Futdados(time),
					       Aquisicao(time),
					       Estrategia(time),
					       Obstaculos(time),
					       Controle(time),
					       Transmissao(time)
{

  estado = false;
  if(sock.connect(ip,(time==TIME_AMARELO?
		      PORTA_AMRL: PORTA_AZUL)) != SOCKET_OK ) {
    cerr << "Erro ao tentar conectar o simulador\n";
    terminar();
  }
  else {
    cout << "Conexao estabelecida com o simulador" << endl;
  }
  // FALTA FAZER: Verificar atributos do thread
  //                            vvvv
  if (pthread_create(&thr_ctrl, NULL, ::main_futrobot, (void*)this)) {
    cerr << "Erro na criacao da thread do futrobot!\n";
    terminar();
  }
}
