#include <GL/glut.h>
#include <math.h>

#include "robo.h"
#include "../parametros.h"

void
desenhaRobo ( const GLfloat * color, const GLfloat * color_ind )
{
  const GLfloat dirColor[ ] = { 0.2, 0.2, 0.2, 1.0 };
  //const GLfloat azul[ ] = { 0.0, 0.0, 0.8, 1.0 };
  GLfloat p = (100*LADO_ROBO/2);

  /* corpo do robo */
  glColor4fv ( dirColor );
  glBegin ( GL_QUADS );
  glVertex3f ( -p, p, 0.0 );
  glVertex3f ( -p, -p, 0.0 );
  glVertex3f ( p, -p, 0.0 );
  glVertex3f ( p, p, 0.0 );
  glEnd ( );


  /* etiquetas do robo */
  glColor4fv ( color );
  /* triangulo superior */
  glBegin(GL_TRIANGLES);
  glVertex2f(0.0, -p);
  glVertex2f(0.0, +p);
  glVertex2f(+p, 0.0);
  glEnd();

  /* retangulo inferior */
  glColor4fv ( color_ind );
  glBegin ( GL_POLYGON );
  glVertex2f(0.0, -p);
  glVertex2f(-p, -p);
  glVertex2f(-p, p);
  glVertex2f(0.0, +p);
  glEnd ( );
}

void
desenhaRobobola ( const GLfloat * color, const GLfloat * color_ind )
{
  const GLfloat dirColor[ ] = { 0.2, 0.2, 0.2, 1.0 };
  const GLfloat azul[ ] = { 0.0, 0.0, 0.8, 1.0 };
  GLfloat p = (100*LADO_ROBO)/2.0;
  GLUquadricObj * q = gluNewQuadric ();
  GLUquadricObj * q2 = gluNewQuadric ();


  /* corpo do robo */
  glColor4fv ( dirColor );
  glBegin ( GL_QUADS );
  glVertex3f ( -p, p, 0.0 );
  glVertex3f ( -p, -p, 0.0 );
  glVertex3f ( p, -p, 0.0 );
  glVertex3f ( p, p, 0.0 );
  glEnd ( );


  p /= 2.0;
  glColor4fv ( color_ind );
  if( color[ 0 ] == azul[ 0 ] )
    {
      glColor4fv ( color_ind );
      glTranslatef (p,p,0.0);
      gluDisk ( q, 0.0, (100*RAIO_MARCA_ROBO), 8, 1);

      glColor4fv ( color );
      glTranslatef (-2*p,-2*p,0.0);
      gluDisk ( q2, 0.0, (100*RAIO_MARCA_ROBO), 8, 1);
    }
  else
    {
      glColor4fv ( color_ind );
      glTranslatef (p,p,0.0);
      gluDisk ( q, 0.0, (100*RAIO_MARCA_ROBO), 8, 1);

      glColor4fv ( color );
      glTranslatef (-2*p,-2*p,0.0);
      gluDisk ( q2, 0.0, (100*RAIO_MARCA_ROBO), 8, 1);
    }
}

void desenhaCampo ( void )
{
  GLdouble larg = (100*ALTURA_CAMPO)/2.0;
  GLdouble comp = (100*LARGURA_CAMPO)/2.0;
  double ang, x, y, x11, x12, y1, x21, x22, y2, x31, x32, y3, x41, x42, y4, seno, cosseno;


  /* campo */
  glColor4f ( 0.0, 0.0, 0.0, 1.0 );
  glBegin ( GL_POLYGON );

  glVertex3f ( -comp, larg -(100*TAMANHO_QUINA), 0.0 );
  glVertex3f ( -comp, -larg+(100*TAMANHO_QUINA), 0.0 );
  glVertex3f ( -comp+(100*TAMANHO_QUINA), -larg, 0.0 );
  glVertex3f ( comp-(100*TAMANHO_QUINA), -larg, 0.0 );
  glVertex3f ( comp, -larg+(100*TAMANHO_QUINA), 0.0 );
  glVertex3f ( comp, larg-(100*TAMANHO_QUINA), 0.0 );
  glVertex3f ( comp-(100*TAMANHO_QUINA), larg, 0.0 );
  glVertex3f ( -comp+(100*TAMANHO_QUINA), larg, 0.0 );

  glEnd ( );

  /* gols */
  glBegin ( GL_QUADS );

  /* esquerda */
  glVertex3f ( -comp-(100*LARGURA_TRAVE), (100*ALTURA_TRAVE)/2.0, 0.0 );
  glVertex3f ( -comp-(100*LARGURA_TRAVE), -(100*ALTURA_TRAVE)/2.0, 0.0 );
  glVertex3f ( -comp-LINHA_LARGURA, -(100*ALTURA_TRAVE)/2.0, 0.0 );
  glVertex3f ( -comp-LINHA_LARGURA, (100*ALTURA_TRAVE)/2.0, 0.0 );

  /* direita */
  glVertex3f ( comp+LINHA_LARGURA, (100*ALTURA_TRAVE)/2.0, 0.0 );
  glVertex3f ( comp+LINHA_LARGURA, -(100*ALTURA_TRAVE)/2.0, 0.0 );
  glVertex3f ( comp+(100*LARGURA_TRAVE), -(100*ALTURA_TRAVE)/2.0, 0.0 );
  glVertex3f ( comp+(100*LARGURA_TRAVE), (100*ALTURA_TRAVE)/2.0, 0.0 );
 
  glEnd ( );


  /* cor e largura das linhas de marcacao */
  glColor4f ( 1.0, 1.0, 1.0, 1.0 );
  glPointSize ( LINHA_LARGURA );

  glBegin ( GL_LINES );

  /* linha central */
  glVertex3f ( 0.0, -larg, 0.0 ); 
  glVertex3f ( 0.0, larg, 0.0 );

  /* area esquerda */
  glVertex3f ( -comp+(100*LARGURA_AREA), (100*ALTURA_AREA)/2.0, 0.0 );
  glVertex3f ( -comp+(100*LARGURA_AREA), -(100*ALTURA_AREA)/2.0, 0.0 );

  glVertex3f ( -comp+(100*LARGURA_AREA), (100*ALTURA_AREA)/2.0, 0.0 );
  glVertex3f ( -comp, (100*ALTURA_AREA)/2.0, 0.0 );

  glVertex3f ( -comp+(100*LARGURA_AREA), -(100*ALTURA_AREA)/2.0, 0.0 );
  glVertex3f ( -comp, -(100*ALTURA_AREA)/2.0, 0.0 );

  /* area direita */
  glVertex3f ( comp-(100*LARGURA_AREA), (100*ALTURA_AREA)/2.0, 0.0 );
  glVertex3f ( comp-(100*LARGURA_AREA), -(100*ALTURA_AREA)/2.0, 0.0 );


  glVertex3f ( comp-(100*LARGURA_AREA), (100*ALTURA_AREA)/2.0, 0.0 );
  glVertex3f ( comp, (100*ALTURA_AREA)/2.0, 0.0 );

  glVertex3f ( comp-(100*LARGURA_AREA), -(100*ALTURA_AREA)/2.0, 0.0 );
  glVertex3f ( comp, -(100*ALTURA_AREA)/2.0, 0.0 );

  /*marcas dos penaltis*/
  glVertex3f ( comp/2.0 - 3.0, 0.0, 0.0 );
  glVertex3f ( comp/2.0 + 3.0, 0.0, 0.0 );

  glVertex3f ( comp/2.0, 3.0, 0.0 );
  glVertex3f ( comp/2.0, -3.0, 0.0 );

  glVertex3f ( -comp/2.0 - 3.0, 0.0, 0.0 );
  glVertex3f ( -comp/2.0 + 3.0, 0.0, 0.0 );

  glVertex3f ( -comp/2.0, 3.0, 0.0 );
  glVertex3f ( -comp/2.0, -3.0, 0.0 );

  /*marcas de bola livre*/
  //1 quadrante
  glVertex3f ( comp/2.0 - 3.0, (100*MARCA_BOLA_LIVRE), 0.0 );
  glVertex3f ( comp/2.0 + 3.0, (100*MARCA_BOLA_LIVRE), 0.0 );

  glVertex3f ( comp/2.0, (100*MARCA_BOLA_LIVRE) + 3.0, 0.0 );
  glVertex3f ( comp/2.0, (100*MARCA_BOLA_LIVRE) - 3.0, 0.0 );

  //2 quadrante
  glVertex3f ( -comp/2.0 - 3.0, (100*MARCA_BOLA_LIVRE), 0.0 );
  glVertex3f ( -comp/2.0 + 3.0, (100*MARCA_BOLA_LIVRE), 0.0 );

  glVertex3f ( -comp/2.0, (100*MARCA_BOLA_LIVRE) + 3.0, 0.0 );
  glVertex3f ( -comp/2.0, (100*MARCA_BOLA_LIVRE) - 3.0, 0.0 );

  //3 quadrante
  glVertex3f ( -comp/2.0 - 3.0, -(100*MARCA_BOLA_LIVRE), 0.0 );
  glVertex3f ( -comp/2.0 + 3.0, -(100*MARCA_BOLA_LIVRE), 0.0 );

  glVertex3f ( -comp/2.0, -(100*MARCA_BOLA_LIVRE) + 3.0, 0.0 );
  glVertex3f ( -comp/2.0, -(100*MARCA_BOLA_LIVRE) - 3.0, 0.0 );

  //4 quadrante
  glVertex3f ( comp/2.0 - 3.0, -(100*MARCA_BOLA_LIVRE), 0.0 );
  glVertex3f ( comp/2.0 + 3.0, -(100*MARCA_BOLA_LIVRE), 0.0 );

  glVertex3f ( comp/2.0, -(100*MARCA_BOLA_LIVRE) + 3.0, 0.0 );
  glVertex3f ( comp/2.0, -(100*MARCA_BOLA_LIVRE) - 3.0, 0.0 );

  glEnd ( );


  /* circulo central */
  glBegin ( GL_POINTS );

  for ( ang = 0.0; ang < 360.0; ang += 1.0 ){
    x = (100*RAIO_CIRCULO) * cos ( M_PI * ang/180.0 );
    y = (100*RAIO_CIRCULO) * sin ( M_PI * ang/180.0 );
    glVertex3f ( x, y, 0.0 );
  }

  glEnd ( );

  glColor4f ( 0.7451, 0.7451, 0.7451, 1.0 );
  //Marca dos robos Bola livre
  glBegin ( GL_POLYGON );

  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    //1 quadrante
    x11 = (comp/2.0 + 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y1 = (100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x11, y1, 0.0 );
  }
  glEnd ( );

  glBegin ( GL_POLYGON );
  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    x12 = (comp/2.0 - 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y1 = (100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x12, y1, 0.0 );
  }
  glEnd ( );

  glBegin ( GL_POLYGON );
  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    //2 quadrante
    x21 = (-comp/2.0 + 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y2 = (100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x21, y2, 0.0 );
  }
  glEnd ( );

  glBegin ( GL_POLYGON );
  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    x22 = (-comp/2.0 - 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y2 = (100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x22, y2, 0.0 );
  }
  glEnd ( );

  glBegin ( GL_POLYGON );
  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    //3 quadrante
    x31 = (-comp/2.0 + 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y3 = (-100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x31, y3, 0.0 );
  }
  glEnd ( );

  glBegin ( GL_POLYGON );
  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    x32 = (-comp/2.0 - 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y3 = (-100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x32, y3, 0.0 );
  }
  glEnd ( );

  glBegin ( GL_POLYGON );
  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    //4 quadrante
    x41 = (comp/2.0 + 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y4 = (-100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x41, y4, 0.0 );
  }
  glEnd ( );

  glBegin ( GL_POLYGON );
  for ( ang = 0.0; ang < 360.0; ang += 45.0 ){
    cosseno = cos ( M_PI * ang/180.0 );
    seno = sin ( M_PI * ang/180.0 );
    x42 = (comp/2.0 - 100*DISTANCIA_BOLA_LIVRE_ROBOS)+((100*RAIO_CIRCULO_BOLA_LIVRE) * cosseno);
    y4 = (-100*MARCA_BOLA_LIVRE)+((100*RAIO_CIRCULO_BOLA_LIVRE) * seno);
    glVertex3f ( x42, y4, 0.0 );
  }
  glEnd ( );
}


void
desenhaBola ( const GLfloat * color )
{
  GLUquadricObj * q = gluNewQuadric ();

  glColor4fv ( color );
  gluDisk ( q, 0.0, 100*RAIO_BOLA, 8, 1);
}
